blob: cc15e5839a3bb663e9f24fad83e2f5a721317686 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
20while [ -h "${prog}" ]; do
21 newProg=`/bin/ls -ld "${prog}"`
22 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
23 if expr "x${newProg}" : 'x/' >/dev/null; then
24 prog="${newProg}"
25 else
26 progdir=`dirname "${prog}"`
27 prog="${progdir}/${newProg}"
28 fi
29done
30oldwd=`pwd`
31progdir=`dirname "${prog}"`
32cd "${progdir}"
33progdir=`pwd`
34prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070035test_dir="test-$$"
36tmp_dir="/tmp/${test_dir}"
jeffhao5d1ac922011-09-29 17:41:15 -070037
38export JAVA="java"
Elliott Hughes9829e332013-03-21 12:38:10 -070039export JAVAC="javac -g -source 1.5 -target 1.5"
jeffhao5d1ac922011-09-29 17:41:15 -070040export RUN="${progdir}/etc/push-and-run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070041export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070042export NEED_DEX="true"
jeffhao5d1ac922011-09-29 17:41:15 -070043
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070044# If dx was not set by the environment variable, assume it is in the path.
45if [ -z "$DX" ]; then
46 export DX="dx"
47fi
48
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080049# If jasmin was not set by the environment variable, assume it is in the path.
50if [ -z "$JASMIN" ]; then
51 export JASMIN="jasmin"
52fi
53
54
jeffhao5d1ac922011-09-29 17:41:15 -070055info="info.txt"
56build="build"
57run="run"
58expected="expected.txt"
59output="output.txt"
60build_output="build-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -070061lib="libartd.so"
jeffhao5d1ac922011-09-29 17:41:15 -070062run_args="--quiet"
63
Brian Carlstrom2613de42012-06-15 17:37:16 -070064target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -070065dev_mode="no"
66update_mode="no"
67debug_mode="no"
Jeff Hao201803f2013-11-20 18:11:39 -080068runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -070069usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -070070build_only="no"
jeffhao5d1ac922011-09-29 17:41:15 -070071
72while true; do
73 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -070074 target_mode="no"
jeffhao5d1ac922011-09-29 17:41:15 -070075 RUN="${progdir}/etc/host-run-test-jar"
TDYa127b92bcab2012-04-08 00:09:51 -070076 DEX_LOCATION=$tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -070077 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -080078 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -070079 target_mode="no"
Jeff Hao201803f2013-11-20 18:11:39 -080080 runtime="jvm"
jeffhao5d1ac922011-09-29 17:41:15 -070081 RUN="${progdir}/etc/reference-run-test-classes"
Elliott Hughesc717eef2012-06-15 16:01:26 -070082 NEED_DEX="false"
jeffhao5d1ac922011-09-29 17:41:15 -070083 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -080084 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -070085 lib="libart.so"
86 shift
87 elif [ "x$1" = "x--dalvik" ]; then
88 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -080089 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -070090 shift
91 elif [ "x$1" = "x--image" ]; then
92 shift
93 image="$1"
94 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -070095 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +000096 elif [ "x$1" = "x-Xcompiler-option" ]; then
97 shift
98 option="$1"
99 run_args="${run_args} -Xcompiler-option $option"
100 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700101 elif [ "x$1" = "x--debug" ]; then
102 run_args="${run_args} --debug"
103 shift
104 elif [ "x$1" = "x--gdb" ]; then
105 run_args="${run_args} --gdb"
106 dev_mode="yes"
107 shift
108 elif [ "x$1" = "x--zygote" ]; then
109 run_args="${run_args} --zygote"
110 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800111 elif [ "x$1" = "x--interpreter" ]; then
112 run_args="${run_args} --interpreter"
113 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700114 elif [ "x$1" = "x--no-verify" ]; then
115 run_args="${run_args} --no-verify"
116 shift
117 elif [ "x$1" = "x--no-optimize" ]; then
118 run_args="${run_args} --no-optimize"
119 shift
120 elif [ "x$1" = "x--no-precise" ]; then
121 run_args="${run_args} --no-precise"
122 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700123 elif [ "x$1" = "x--invoke-with" ]; then
124 shift
125 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700126 if [ "x$what" = "x" ]; then
127 echo "$0 missing argument to --invoke-with" 1>&2
128 usage="yes"
129 break
130 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700131 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700132 shift
133 elif [ "x$1" = "x--dev" ]; then
134 run_args="${run_args} --dev"
135 dev_mode="yes"
136 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700137 elif [ "x$1" = "x--build-only" ]; then
138 build_only="yes"
139 shift
140 elif [ "x$1" = "x--output-path" ]; then
141 shift
142 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700143 if [ "x$tmp_dir" = "x" ]; then
144 echo "$0 missing argument to --output-path" 1>&2
145 usage="yes"
146 break
147 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700148 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700149 elif [ "x$1" = "x--update" ]; then
150 update_mode="yes"
151 shift
152 elif [ "x$1" = "x--help" ]; then
153 usage="yes"
154 shift
155 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700156 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700157 usage="yes"
158 break
159 else
160 break
161 fi
162done
163
Jeff Hao201803f2013-11-20 18:11:39 -0800164if [ ! "$runtime" = "jvm" ]; then
165 run_args="${run_args} --lib $lib"
166fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700167
Jeff Hao201803f2013-11-20 18:11:39 -0800168if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700169 if [ "$target_mode" = "no" ]; then
170 framework="${OUT}/system/framework"
171 bpath="${framework}/core.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/core-junit.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
172 run_args="${run_args} --boot -Xbootclasspath:${bpath}"
173 else
174 true # defaults to using target BOOTCLASSPATH
175 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800176elif [ "$runtime" = "art" ]; then
177 if [ "$target_mode" = "no" ]; then
Brian Carlstrom43534862014-02-19 01:13:52 -0800178 # ANDROID_BUILD_TOP and ANDROID_HOST_OUT are not set in a build environment.
179 if [ -z "$ANDROID_BUILD_TOP" ]; then
180 export ANDROID_BUILD_TOP=$oldwd
181 fi
182 if [ -z "$ANDROID_HOST_OUT" ]; then
183 export ANDROID_HOST_OUT=$ANDROID_BUILD_TOP/out/host/linux-x86
184 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800185 run_args="${run_args} --boot -Ximage:${ANDROID_HOST_OUT}/framework/core.art"
186 else
187 run_args="${run_args} --boot -Ximage:/data/art-test/core.art"
188 fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700189fi
190
jeffhao5d1ac922011-09-29 17:41:15 -0700191if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
192 echo "--dev and --update are mutually exclusive" 1>&2
193 usage="yes"
194fi
195
196if [ "$usage" = "no" ]; then
197 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
198 test_dir=`basename "$oldwd"`
199 else
200 test_dir="$1"
201 fi
202
203 if [ '!' -d "$test_dir" ]; then
204 td2=`echo ${test_dir}-*`
205 if [ '!' -d "$td2" ]; then
206 echo "${test_dir}: no such test directory" 1>&2
207 usage="yes"
208 fi
209 test_dir="$td2"
210 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700211 # Shift to get rid of the test name argument. The rest of the arguments
212 # will get passed to the test run.
213 shift
214fi
215
216if [ "$usage" = "yes" ]; then
217 prog=`basename $prog`
218 (
219 echo "usage:"
220 echo " $prog --help Print this message."
221 echo " $prog [options] [test-name] Run test normally."
222 echo " $prog --dev [options] [test-name] Development mode" \
223 "(dumps to stdout)."
224 echo " $prog --update [options] [test-name] Update mode" \
225 "(replaces expected.txt)."
226 echo ' Omitting the test name or specifying "-" will use the' \
227 "current directory."
228 echo " Runtime Options:"
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000229 echo " -O Run non-debug rather than debug build (off by default)."
230 echo " -Xcompiler-option Pass an option to the compiler."
231 echo " --debug Wait for a debugger to attach."
232 echo " --gdb Run under gdb; incompatible with some tests."
233 echo " --build-only Build test files only (off by default)."
234 echo " --interpreter Enable interpreter only mode (off by default)."
235 echo " --no-verify Turn off verification (on by default)."
236 echo " --no-optimize Turn off optimization (on by default)."
237 echo " --no-precise Turn off precise GC (on by default)."
238 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700239 "If used, then the"
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000240 echo " other runtime options are ignored."
241 echo " --host Use the host-mode virtual machine."
242 echo " --invoke-with Pass --invoke-with option to runtime."
243 echo " --dalvik Use Dalvik (off by default)."
244 echo " --jvm Use a host-local RI virtual machine."
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700245 echo " --output-path [path] Location where to store the build" \
246 "files."
jeffhao5d1ac922011-09-29 17:41:15 -0700247 ) 1>&2
248 exit 1
249fi
250
251cd "$test_dir"
252test_dir=`pwd`
253
254td_info="${test_dir}/${info}"
255td_expected="${test_dir}/${expected}"
256
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700257if [ ! -r $td_info ]; then
258 echo "${test_dir}: missing file $td_info" 1>&2
259 exit 1
260fi
261
262if [ ! -r $td_expected ]; then
263 echo "${test_dir}: missing file $td_expected" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700264 exit 1
265fi
266
267# copy the test to a temp dir and run it
268
Elliott Hughes510c8782011-10-06 10:57:34 -0700269echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700270
271rm -rf "$tmp_dir"
272cp -Rp "$test_dir" "$tmp_dir"
273cd "$tmp_dir"
274
275if [ '!' -r "$build" ]; then
276 cp "${progdir}/etc/default-build" build
277fi
278
279if [ '!' -r "$run" ]; then
280 cp "${progdir}/etc/default-run" run
281fi
282
283chmod 755 "$build"
284chmod 755 "$run"
285
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700286export TEST_NAME=`basename ${test_dir}`
287
jeffhao5d1ac922011-09-29 17:41:15 -0700288good="no"
289if [ "$dev_mode" = "yes" ]; then
290 "./${build}" 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700291 build_exit="$?"
292 echo "build exit status: $build_exit" 1>&2
293 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800294 echo "${test_dir}: running..." 1>&2
295 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700296 run_exit="$?"
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800297 echo "run exit status: $run_exit" 1>&2
298 if [ "$run_exit" = "0" ]; then
299 good="yes"
300 fi
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700301 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700302elif [ "$update_mode" = "yes" ]; then
303 "./${build}" >"$build_output" 2>&1
304 build_exit="$?"
305 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800306 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700307 "./${run}" $run_args "$@" >"$output" 2>&1
308 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
309 good="yes"
310 else
311 cat "$build_output" 1>&2
312 echo "build exit status: $build_exit" 1>&2
313 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700314elif [ "$build_only" = "yes" ]; then
315 good="yes"
316 "./${build}" >"$build_output" 2>&1
317 build_exit="$?"
318 if [ "$build_exit" '!=' '0' ]; then
319 cp "$build_output" "$output"
320 echo "build exit status: $build_exit" >>"$output"
321 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
322 if [ "$?" '!=' "0" ]; then
323 good="no"
324 echo "BUILD FAILED For ${TEST_NAME}"
325 fi
326 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700327 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700328 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700329 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700330else
331 "./${build}" >"$build_output" 2>&1
332 build_exit="$?"
333 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800334 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700335 "./${run}" $run_args "$@" >"$output" 2>&1
336 else
337 cp "$build_output" "$output"
338 echo "build exit status: $build_exit" >>"$output"
339 fi
340 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
341 if [ "$?" = "0" ]; then
342 # output == expected
343 good="yes"
344 echo "${test_dir}: succeeded!" 1>&2
345 fi
346fi
347
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700348# Clean up test files.
349if [ "$good" == "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700350 cd "$oldwd"
351 rm -rf "$tmp_dir"
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700352 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
Brian Carlstrom105215d2012-06-14 12:50:44 -0700353 adb shell rm -r $DEX_LOCATION
354 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700355 exit 0
356fi
357
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700358
jeffhao5d1ac922011-09-29 17:41:15 -0700359(
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700360 if [ "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700361 echo "${test_dir}: FAILED!"
362 echo ' '
363 echo '#################### info'
364 cat "${td_info}" | sed 's/^/# /g'
365 echo '#################### diffs'
366 diff --strip-trailing-cr -u "$expected" "$output"
367 echo '####################'
368 echo ' '
369 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -0700370 echo "${TEST_NAME} files left in ${tmp_dir} on host"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700371 if [ "$target_mode" == "yes" ]; then
Brian Carlstrom105215d2012-06-14 12:50:44 -0700372 echo "and in ${DEX_LOCATION} on target"
373 fi
374
jeffhao5d1ac922011-09-29 17:41:15 -0700375) 1>&2
376
377exit 1